# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pike character`|` (e.g. `|ABC123`).  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from redrover_api.configuration import Configuration


class SimplePerson(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'external_id': 'str',
        'first_name': 'str',
        'middle_name': 'str',
        'last_name': 'str',
        'source_organization_id': 'int'
    }

    attribute_map = {
        'id': 'id',
        'external_id': 'externalId',
        'first_name': 'firstName',
        'middle_name': 'middleName',
        'last_name': 'lastName',
        'source_organization_id': 'sourceOrganizationId'
    }

    def __init__(self, id=None, external_id=None, first_name=None, middle_name=None, last_name=None, source_organization_id=None, local_vars_configuration=None):  # noqa: E501
        """SimplePerson - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._external_id = None
        self._first_name = None
        self._middle_name = None
        self._last_name = None
        self._source_organization_id = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.external_id = external_id
        self.first_name = first_name
        self.middle_name = middle_name
        self.last_name = last_name
        if source_organization_id is not None:
            self.source_organization_id = source_organization_id

    @property
    def id(self):
        """Gets the id of this SimplePerson.  # noqa: E501

        Red Rover internal id of the user  # noqa: E501

        :return: The id of this SimplePerson.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SimplePerson.

        Red Rover internal id of the user  # noqa: E501

        :param id: The id of this SimplePerson.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def external_id(self):
        """Gets the external_id of this SimplePerson.  # noqa: E501

        External Id of the user  # noqa: E501

        :return: The external_id of this SimplePerson.  # noqa: E501
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """Sets the external_id of this SimplePerson.

        External Id of the user  # noqa: E501

        :param external_id: The external_id of this SimplePerson.  # noqa: E501
        :type: str
        """

        self._external_id = external_id

    @property
    def first_name(self):
        """Gets the first_name of this SimplePerson.  # noqa: E501

        User's first name  # noqa: E501

        :return: The first_name of this SimplePerson.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this SimplePerson.

        User's first name  # noqa: E501

        :param first_name: The first_name of this SimplePerson.  # noqa: E501
        :type: str
        """

        self._first_name = first_name

    @property
    def middle_name(self):
        """Gets the middle_name of this SimplePerson.  # noqa: E501

        User's middle name  # noqa: E501

        :return: The middle_name of this SimplePerson.  # noqa: E501
        :rtype: str
        """
        return self._middle_name

    @middle_name.setter
    def middle_name(self, middle_name):
        """Sets the middle_name of this SimplePerson.

        User's middle name  # noqa: E501

        :param middle_name: The middle_name of this SimplePerson.  # noqa: E501
        :type: str
        """

        self._middle_name = middle_name

    @property
    def last_name(self):
        """Gets the last_name of this SimplePerson.  # noqa: E501

        User's last name  # noqa: E501

        :return: The last_name of this SimplePerson.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this SimplePerson.

        User's last name  # noqa: E501

        :param last_name: The last_name of this SimplePerson.  # noqa: E501
        :type: str
        """

        self._last_name = last_name

    @property
    def source_organization_id(self):
        """Gets the source_organization_id of this SimplePerson.  # noqa: E501


        :return: The source_organization_id of this SimplePerson.  # noqa: E501
        :rtype: int
        """
        return self._source_organization_id

    @source_organization_id.setter
    def source_organization_id(self, source_organization_id):
        """Sets the source_organization_id of this SimplePerson.


        :param source_organization_id: The source_organization_id of this SimplePerson.  # noqa: E501
        :type: int
        """

        self._source_organization_id = source_organization_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SimplePerson):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SimplePerson):
            return True

        return self.to_dict() != other.to_dict()
